# 2021-07-08 Meeting

## Attendees

- Derek Ardolf
- Bryce Larson
- Gary Giesen
- Ken Jordan

## Meeting Details

- [Updates](#updates)
- [Paths for docs.saltproject.io publishing](#paths-for-docs.saltproject.io-publishing)
- [Landing page refresh](#landing-page-refresh)
- [Main `salt` docs theme refresh](#main-salt-docs-theme-refresh)
- [Next steps](#next-steps)
- [Going forward](#going-forward)

## Updates

- All the MRs in the `salt-user-guide` repo have been reviewed and merged
- Last month's working group had the Good Docs Project as part of the group:
  - [YouTube: Salt Docs Working Group 2021-06-10 with the Good Docs Project](https://www.youtube.com/watch?v=wDNyaolGbgc&list=PL9svBjLDUl_9uKyNTiBHjO6HDmquR83Ja&index=21)

## Paths for docs.saltproject.io publishing

Where will we publish new docsets such as `salt-user-guide`, `salt-install-guide`, etc. and where would non-`salt`
specific projects have their HTML docs published?

### Current implementation

- Main portal: `docs.saltproject.io/en/latest`: Forwarded from (`docs.saltproject.io`)
- `salt` docs: `docs.saltproject.io/en/<version>/contents.html`
- `getstarted` docs: `docs.saltproject.io/en/getstarted`

### Suggested implementation

Organize the URL paths by project type, with parent project main docs being in
a `docs` path.

What this would look like:

- Main portal: `docs.saltproject.io`
- `salt` HTML docs: `docs.saltproject.io/salt/docs/en/<version>`
  - `salt-user-guide` HTML docs: `docs.saltproject.io/salt/user-guide/en/<version>`
  - `salt-install-guide` HTML docs: `docs.saltproject.io/salt/install-guide/en/<version>`
- `pop` HTML docs: `docs.saltproject.io/pop/docs/en/<version>`
  - `pop-create` HTML docs: `docs.saltproject.io/pop/pop-create/en/<version>`
- `tiamat` HTML docs: `docs.saltproject.io/tiamat/docs/en/<version>`

This would look like:

```bash
../
salt/docs/  # salt repo HTML
salt/user-guide/  # salt-user-guide HTML
salt/install-guide/  # salt-install-guide HTML
pop/docs/  # pop repo HTML
pop/pop-create/  # pop-create repo HTML
tiamat/docs/  # tiamat repo HTML
```

> This may create problems with the `salt` docs, specifically, due to a mix of absolute vs. relative
  links in generated HTML. We'd also have to ensure we implement redirects in order to avoid breaking
  any links out in the wild.

This also makes searching from search engines either, like doing:

```bash
# Search for docs containing "azure"
# throughout all idem / idem plugin docs
site:docs.saltproject.io/idem/ azure
```

#### Provide dir tree at each root

We feel it would be beneficial if the tree can be easily viewed, or searched,
via the parent category path.

Example: When looking at https://docs.saltproject.io/en/, users can see all available
documentation sub-paths. This currently looks like:

```text
../
3000/  # Version of salt docs
3001/  # Version of salt docs
3002/  # Version of salt docs
3003/  # Version of salt docs
epub/  # epubs generated of salt docs
getstarted/ # Getting started guide (will eventually be deprecated)
latest/  # Version of salt docs (currently shows 3003 docs)
master/  # Version of salt docs (shows live docs from master branch)
pdf/ # PDFs generated of salt docs
```

This could translate to something like the suggested `docs.saltproject.io/salt` tree showing:

```text
../
docs/
user-guide/
install-guide/
```

It would also be beneficial to have a simple table showing the root paths, similar
to what is shown on https://repo.saltproject.io/#directory-listing. This could mean
an easy glance of the site paths:

```text
../
salt/
pop/
idem/
tiamat/
```

## Landing page refresh

It would likely be beneficial to eventually replace the homepage of `docs.saltproject.io` with
a Hugo-generated static site instead of the current Acrylamid (Python 2) generated site. We could
integrate an Algolia and/or DuckDuckGo search box, and have a nice layout for easy discovery
where people can jump to the docs that they are most interested in.

Some example references that have many docsets:

- [Tanzu docs landing](https://docs.pivotal.io/)
- [Splunk docs landing](https://docs.splunk.com/Documentation)
- [AWS docs landing](https://docs.aws.amazon.com/index.html)

## Main `salt` docs theme refresh

We've been using [Furo](https://pradyunsg.me/furo/) as our theme of choice for Sphinx documentation. It is currently what `salt-user-guide`, `salt-install-guide`, and other Salt Project repos use. `salt` should migrate over to the new theme in order to bring uniformity across docsets.

### Prereqs

- [Evaluate and make us of Sphinx v3.x - v4.x new features we find useful](https://gitlab.com/saltstack/open/docs/salt-user-guide/-/issues/48)
- [Transition to using purely remote URL targets for Salt Project logo and favicon](https://gitlab.com/saltstack/open/docs/salt-user-guide/-/issues/47)

### Testing `furo`

The easiest path may be to get `furo` working in a fork of `salt` with `nox -e 'docs-html(compress=False, clean=True)'`. This would help assist in seeing how much work would be required to transition to the new theme and would also help us understand what custom work exists in the [`saltstack2` Sphinx theme](https://github.com/saltstack/salt/tree/master/doc/_themes/saltstack2) used by the current `salt` docs. Though, that wouldn't be good enough to merge into `salt` yet, as we'd need to understand how it functions when using multiple versions.

The best way to test that would be to create a testing fork of builddocs that makes use of Furo, and try to make use of Furo's versioning.

## Next steps

- Publish the `salt-user-guide` to `docs.saltproject.io/salt/user-guide/`
- Publish the `salt-install-guide` to `docs.saltproject.io/salt/install-guide/`
- See about implementing Algolia for the current as-is docs portal

### Misc tasks

- Update docs landing page for book link:
  - Old link: http://www.oreilly.com/webops-perf/free/network-automation-at-scale.csp
  - New link: https://www.cloudflare.com/network-automation-at-scale-ebook/
- Duplicate content from [VMware KB on Upgrading Salt](https://kb.vmware.com/s/article/50122319?lang=en_US&queryTerm=upgrading+your+salt+infrastructure) to [Salt docs on upgrading](https://docs.saltproject.io/en/master/topics/installation/index.html#upgrading-salt)
- Add [Quick Guide to Vault Integration](https://web.archive.org/web/20210306232428/https://help.saltstack.com/hc/en-us/articles/360041140451-Quick-Guide-to-Vault-Integration) tutorial to `salt-user-guide`

## Going forward

The goal of the next Salt Docs Working Group is to continue our action-oriented
approach: assigning issues, seeking help with issues, and working toward achieving
the long-term goals by completing tasks step-by-step. We'll go over issues available,
MRs/PRs needing review/feedback, and what progress has been made.

The current focus will continue be on:
- [`salt-user-guide`](https://gitlab.com/saltstack/open/docs/salt-user-guide)
- [`salt-install-guide`](https://gitlab.com/saltstack/open/docs/salt-install-guide)

Issues are available in both repos, and are open for contributions!
